#!/usr/bin/env node
import { I as c, S as a } from "./types-a1ee6691.js";
import { log as n, _get as I, getConfigFileCommonOptions as h, initHandlerCommon as _, _set as b, readConfigFile as k, _curry as A, createSubcommand as N, createMainCommand as w } from "@done-coding/cli-utils";
import F from "node:path";
import m from "node:fs";
const G = ({
  sourceJson: e,
  targetKey: o,
  keyConfig: t
}) => {
  let s;
  typeof t == "string" ? s = {
    type: c.FIXED,
    value: t
  } : s = t;
  const { type: l = c.READ } = s;
  switch (l) {
    case c.REG: {
      const { sourceKey: r, pattern: d, replaceValue: p, flags: g } = s, E = new RegExp(d, g ?? void 0), i = I(e, r);
      return typeof i == "string" ? i.replace(E, p) : (n.warn(
        `${i}不是字符串类型，无法使用正则表达式进行替换，此处将直接返回原值`
      ), i);
    }
    case c.FIXED: {
      const { value: r } = s;
      return r;
    }
    case c.READ: {
      const { sourceKey: r = o } = s;
      return I(e, r);
    }
    default: {
      n.warn(`未知的配置类型${l}`);
      return;
    }
  }
}, D = {
  sourceFilePath: "./package.json",
  keyConfigMap: {
    name: {
      type: c.READ
    },
    version: {
      type: c.READ
    },
    description: {
      type: c.READ
    }
  },
  injectFilePath: "./src/injectInfo.json"
}, R = {
  name: "@done-coding/cli-inject",
  version: "0.5.8-alpha.0",
  description: "信息(JSON)注入命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "inject"
  }
}, {
  cliConfig: { namespaceDir: M, moduleName: x }
} = R, H = `./${M}/${x}`, T = `${H}.json`, L = () => h({
  configPathDefault: T
}), J = async (e) => _(D, e, {
  onFileGenerated: () => {
    n.info("文件生成成功");
  }
}), U = () => ({
  ...h({
    configPathDefault: T
  })
}), V = async ({
  rootDir: e = process.cwd(),
  config: o = D,
  keyConfigMap: t = {}
} = {}) => {
  const {
    sourceFilePath: s,
    keyConfigMap: l,
    injectFilePath: r
  } = o, d = {
    ...l,
    ...t
  };
  if (!s.endsWith(".json"))
    return n.error("源文件必须是json"), process.exit(1);
  if (!r.endsWith(".json"))
    return n.error("注入文件必须是json"), process.exit(1);
  const p = F.resolve(e, s), g = m.readFileSync(p, "utf-8"), E = JSON.parse(g), i = Object.entries(d).reduce(
    (f, [C, $]) => {
      const P = G({ sourceJson: E, targetKey: C, keyConfig: $ });
      return b(f, C, P), f;
    },
    {}
  ), u = F.resolve(e, r), y = JSON.stringify(i, null, 2);
  if (m.existsSync(u)) {
    const f = m.readFileSync(u, "utf-8");
    if (y === f)
      return n.skip("注入文件已存在且内容相同，无需重复注入"), i;
    n.stage("文件内容变化,开始覆盖注入文件");
  } else
    n.stage("开始注入文件");
  m.writeFileSync(u, y), n.success(`文件注入成功: ${u}`), n.info(y);
}, K = async (e) => {
  const o = await k(e);
  if (!o)
    return n.error("配置文件为空"), process.exit(1);
  const { rootDir: t } = e;
  await V({ rootDir: t, config: o });
}, v = async (e, o) => e === a.INIT ? J(o) : e === a.GENERATE ? K(o) : (n.error(`无效的命令: ${e}`), process.exit(1)), {
  version: W,
  description: X,
  cliConfig: { moduleName: j }
} = R, q = {
  command: a.INIT,
  describe: "初始化提取配置文件",
  options: L(),
  handler: A(v)(
    a.INIT
  )
}, z = {
  command: a.GENERATE,
  describe: "提取信息",
  options: U(),
  handler: A(v)(
    a.GENERATE
  )
}, O = {
  describe: X,
  version: W,
  subcommands: [q, z].map(
    N
  ),
  demandCommandCount: 1
}, S = (e = !1) => {
  const o = e ? j : void 0, t = `$0${e ? ` ${j}` : ""} <command> [options]`;
  return { command: o, usage: t };
}, ee = async () => w({
  ...O,
  ...S()
}), ne = () => N({
  ...O,
  ...S(!0)
});
export {
  ne as a,
  ee as c,
  V as g,
  v as h,
  G as k
};
